#ifndef BUFFERSUPPORT_H
#define BUFFERSUPPORT_H

const int maxArraySize = 10240;  //Max allocation size  
//TODO: this is currently the allocation size for all buffers, waisting memory. Since all actions are performed on the initiated buffersize variable, it does not waste performance, it only leaves memory unused.

class BufferSupport
{

public:
    //constructor
    // BufferSupport(int bufferSize);
    BufferSupport();

    //methods
    bool initBuffer(int bufferSize, int initialPointerPosition);
    void lockBuffer();
    void unlockBuffer();
    void clearBuffer();

    //getters
    bool isBufferLocked();
    int getPointerPosition();
    int getBufferSize();

    //setters
    bool setPointerPosition(int pointerPosition);

    //variable
    unsigned char buffer[maxArraySize]; //TODO: I do not want to allocate a fixed size here, but c-type arrays are not very dynamic :(

private:
    int _bufferSize;
    bool _bufferLocked;
    int _pointerPosition;
};


#endif // BUFFERSUPPORT_H