//this include file contains constants used in the code for the instrumented object.

#ifndef INSTRUMENTEDOBJECTHELPERS_H   //TODO: #pragma once might be better
#define INSTRUMENTEDOBJECTHELPERS_H  

#include <WString.h>
#include <Arduino.h>

namespace helpers
{
  enum verboseLevels
  {
    silent = 0,  // print nothing in the custom code. External libraries will still output debug info.
    error = 1,   // print all error messages
    info = 2,    // print all error and info messages
    extraBT = 3, //3 and above: print messages only used during development (can cause performance issues!)
    extraSensor = 4,
    extraTiming = 5,
    extraBuffers = 6
  };

  extern const int getVerboseLevel();

  extern String verboseLevelToString(int verboseLevelToConvert);


  //check the verboseLevels, add time and print to USB "Serial" terminal
  extern void printToLog(String messsage, int verboseLevelOfThisMessage);
  extern void printToLog(String messsage, int verboseLevelOfThisMessage, int errorLedGPIO);  //when defining the error LED GPIO, it will turn on when a message with level error is given
  


}


#endif //INSTRUMENTEDOBJECTHELPERS_H